#include <windows.h>
#include <ddraw.h>

#include "define_data.h"
#include "define_char.h"
#include "character.h"
#include "cell.h"

extern CCharacter *pchar[2];
DWORD gf_Nage1(LPVOID pedat){return(  pchar[0]->act_nagee((CHARACTERINFO2*)pedat));}
DWORD gf_Nage2(LPVOID pedat){return(  pchar[1]->act_nagee((CHARACTERINFO2*)pedat));}
DWORD gf_Nobin1(LPVOID pedat){return(  pchar[0]->act_nobine((CHARACTERINFO2*)pedat));}
DWORD gf_Nobin2(LPVOID pedat){return(  pchar[1]->act_nobine((CHARACTERINFO2*)pedat));}


DWORD hm,vm,eaid;

CCharacter::CCharacter(CHARACTERINFO2 *info)
{
	pdat=info;

//
	wind.cid	=pdat->cid;
	wind.type	=0;
	windcr[0]=736;
	windcr[1]=737;
	windcr[2]=-1;
	windcd[0]=737;
	windcd[1]=-1;
	wind.cell_run=windcr;
	wind.cell_dis=windcd;
	wind.spd_run	=3;
	wind.spd_dis	=2;
	wind.vx=2;
	wind.vy=0;
	wind.ax=wind.ay=0;
	wind.dur=14;
	wind.state=0;
	wind.info_b=NULL;

//
	sand.cid	=pdat->cid;
	sand.type	=0;
	sandcr[0]=738;
	sandcr[1]=739;
	sandcr[2]=740;
	sandcr[3]=741;
	sandcr[4]=741 + pdat->counter%2;
	sandcr[5]=-1;
	sandcd[0]=742;
	sandcd[1]=743;
	sandcd[2]=744;
	sandcd[3]=745;
	sandcd[4]=746;
	sandcd[5]=0;
	sandcd[6]=746;
	sandcd[7]=-1;
	sand.cell_run=sandcr;
	sand.cell_dis=sandcd;
	sand.spd_run	=3;
	sand.spd_dis	=2;
	sand.vx=2;
	sand.vy=0;
	sand.ax=sand.ay=0;
	sand.dur=14;
	sand.state=0;
	sand.info_b=NULL;

//C
	nori.cid	=pdat->cid;
	nori.type	=BULLETA_DRAWBACK;
	noricr[0]=369;
	noricr[1]=-1;
	noricd[0]=-1;
	nori.cell_run=noricr;
	nori.cell_dis=noricd;
	nori.spd_run	=1;
	nori.spd_dis	=1;
	nori.vx=0;
	nori.vy=0;
	nori.ax=nori.ay=0;
	nori.dur=20;
	nori.state=0;
	nori.info_b=NULL;

//
	shigma.cid	=pdat->cid;
	shigma.type	=0;
	shigmacr[0]=1011;
	shigmacr[1]=-1;
	shigmacd[0]=-1;
	shigma.cell_run=shigmacr;
	shigma.cell_dis=shigmacd;
	shigma.spd_run	=1;
	shigma.spd_dis	=1;
	shigma.vx=0;
	shigma.vy=0;
	shigma.ax=shigma.ay=0;
	shigma.dur=10;
	shigma.state=0;
	shigma.info_b=NULL;

//䎌uLbIv
	serifuk.cid	=pdat->cid;
	serifuk.type	=0;
	serifukcr[0]=392;
	serifukcr[1]=-1;
	serifukcd[0]=-1;
	serifuk.cell_run=serifukcr;
	serifuk.cell_dis=serifukcd;
	serifuk.spd_run	=1;
	serifuk.spd_dis	=1;
	serifuk.vx=0;
	serifuk.vy=0;
	serifuk.ax=serifuk.ay=0;
	serifuk.dur=20;
	serifuk.state=0;
	serifuk.info_b=NULL;

//䎌uȂv
	serifuy.cid	=pdat->cid;
	serifuy.type	=0;
	serifuycr[0]=393;
	serifuycr[1]=-1;
	serifuycd[0]=-1;
	serifuy.cell_run=serifuycr;
	serifuy.cell_dis=serifuycd;
	serifuy.spd_run	=1;
	serifuy.spd_dis	=1;
	serifuy.vx=0;
	serifuy.vy=0;
	serifuy.ax=serifuy.ay=0;
	serifuy.dur=20;
	serifuy.state=0;
	serifuy.info_b=NULL;

//䎌uuCv
	serifud.cid	=pdat->cid;
	serifud.type	=0;
	serifudcr[0]=394;
	serifudcr[1]=-1;
	serifudcd[0]=-1;
	serifud.cell_run=serifudcr;
	serifud.cell_dis=serifudcd;
	serifud.spd_run	=1;
	serifud.spd_dis	=1;
	serifud.vx=0;
	serifud.vy=0;
	serifud.ax=serifud.ay=0;
	serifud.dur=20;
	serifud.state=0;
	serifud.info_b=NULL;

//ɂ
	onigiri.cid	=pdat->cid;
	onigiri.type	=0;
	onigiricr[0]=367;
	onigiricr[1]=368;
	onigiricr[2]=-1;
	onigiricd[0]=-1;
	onigiri.cell_run=onigiricr;
	onigiri.cell_dis=onigiricd;
	onigiri.spd_run	=6;
	onigiri.spd_dis	=2;
	onigiri.vx=0;
	onigiri.vy=0;
	onigiri.ax=onigiri.ay=0;
	onigiri.dur=80;
	onigiri.state=0;
	onigiri.info_b=NULL;

//ɂd
	onizura.cid	=pdat->cid;
	onizura.type	=0;
	onizuracr[0]=370;
	onizuracr[1]=370;
	onizuracr[2]=371;
	onizuracr[3]=-1;
	onizuracd[0]=-1;
	onizura.cell_run=onizuracr;
	onizura.cell_dis=onizuracd;
	onizura.spd_run	=6;
	onizura.spd_dis	=2;
	onizura.vx=0;
	onizura.vy=0;
	onizura.ax=onizura.ay=0;
	onizura.dur=80;
	onizura.state=0;
	onizura.info_b=NULL;

//8g
	htoushin.cid	=pdat->cid;
	htoushin.type	=0;
	htoushincr[0]=372;
	htoushincr[1]=373;
	htoushincr[2]=374;
	htoushincr[3]=-1;
	htoushincd[0]=-1;
	htoushin.cell_run=htoushincr;
	htoushin.cell_dis=htoushincd;
	htoushin.spd_run	=4;
	htoushin.spd_dis	=2;
	htoushin.vx=0;
	htoushin.vy=0;
	htoushin.ax=htoushin.ay=0;
	htoushin.dur=80;
	htoushin.state=0;
	htoushin.info_b=NULL;

//1
	ichisan.cid	=pdat->cid;
	ichisan.type	=0;
	ichisancr[0]=353;
	ichisancr[1]=354;
	ichisancr[2]=355;
	ichisancr[3]=-1;
	ichisancd[0]=-1;
	ichisan.cell_run=ichisancr;
	ichisan.cell_dis=ichisancd;
	ichisan.spd_run	=3;
	ichisan.spd_dis	=2;
	ichisan.vx=0;
	ichisan.vy=0;
	ichisan.ax=ichisan.ay=0;
	ichisan.dur=80;
	ichisan.state=0;
	ichisan.info_b=NULL;

//r[
	bbeam.cid	=pdat->cid;
	bbeam.type	=0;
	bbeamcr[0]=382;
	bbeamcr[1]=382;
	bbeamcr[2]=-1;
	bbeamcd[0]=382;
	bbeamcd[1]=384;
	bbeamcd[2]=385;
	bbeamcd[3]=386;
	bbeamcd[4]=387;
	bbeamcd[5]=388;
	bbeamcd[6]=389;
	bbeamcd[7]=390;
	bbeamcd[8]=391;
	bbeamcd[9]=-1;
	bbeam.cell_run=bbeamcr;
	bbeam.cell_dis=bbeamcd;
	bbeam.spd_run	=3;
	bbeam.spd_dis	=2;
	bbeam.vx=0;
	bbeam.vy=0;
	bbeam.ax=bbeam.ay=0;
	bbeam.dur=14;
	bbeam.state=0;
	bbeam.info_b=NULL;

//܂
	itachi.cid		=pdat->cid;
	itachi.type	=BULLETA_VSHUMAN | BULLETA_VSBULLET | BULLETA_XJIMENN;
	itachicr[0]=585;
	itachicr[1]=-1;
	itachicd[0]=-1;
	itachi.cell_run=itachicr;
	itachi.cell_dis=itachicd;
	itachi.spd_run	=1;
	itachi.spd_dis	=3;
	itachi.dur=90;
	itachi.state=0;
	itachi.info_b=NULL;

//^
	flood.cid		=pdat->cid;
	flood.type	=BULLETA_VSHUMAN | BULLETA_VSBULLET | BULLETA_DONOTDIE;
	floodcr[0]=886;
	floodcr[1]=886;
	floodcr[2]=886;
	floodcr[3]=-1;
	floodcd[0]=-1;
	flood.cell_run=floodcr;
	flood.cell_dis=floodcd;
	flood.spd_run	=2;
	flood.spd_dis	=3;
	flood.dur=90;
	flood.state=0;
	flood.info_b=NULL;

//^̒ǉU
	fatack[0].cid	=pdat->cid;
	fatack[0].type	=BULLETA_VSHUMAN | BULLETA_VSBULLET;
	fatackcr[0]=894;
	fatackcr[1]=-1;
	fatackcd[0]=-1;
	fatack[0].cell_run=fatackcr;
	fatack[0].cell_dis=fatackcd;
	fatack[0].spd_run	=1;
	fatack[0].spd_dis	=1;
	fatack[0].vx=0;
	fatack[0].vy=0;
	fatack[0].ax=0;
	fatack[0].ay=0;
	fatack[0].dur=70;
	fatack[0].state=0;
	fatack[0].info_b=NULL;
	
	fatack[1] = fatack[0];

//܂
	miztamari.cid	=pdat->cid;
	miztamari.type	=BULLETA_DRAWBACK;
	miztamaricr[0]=895;
	miztamaricr[1]=895;
	miztamaricr[2]=895;
	miztamaricr[3]=-1;
	miztamaricd[0]=0;
	miztamaricd[1]=900;
	miztamaricd[2]=-1;
	miztamari.cell_run=miztamaricr;
	miztamari.cell_dis=miztamaricd;
	miztamari.spd_run	=4;
	miztamari.spd_dis	=2;
	miztamari.vx=0;
	miztamari.vy=0;
	miztamari.ax=miztamari.ay=0;
	miztamari.dur=80;
	miztamari.state=0;
	miztamari.info_b=NULL;

//Ԃ
	mizshibuki[0].cid	=pdat->cid;
	mizshibuki[0].type	=0;
	mizshibukicr[0]=901;
	mizshibukicr[1]=902;
	mizshibukicr[2]=903;
	mizshibukicr[3]=904;
	mizshibukicr[4]=905;
	mizshibukicr[5]=906;
	mizshibukicr[6]=907;
	mizshibukicr[7]=-1;
	mizshibukicd[0]=-1;
	mizshibuki[0].cell_run=mizshibukicr;
	mizshibuki[0].cell_dis=mizshibukicd;
	mizshibuki[0].spd_run	=1;
	mizshibuki[0].spd_dis	=1;
	mizshibuki[0].vx=2;
	mizshibuki[0].vy=0;
	mizshibuki[0].ax=mizshibuki[0].ay=0;
	mizshibuki[0].dur=7;
	mizshibuki[0].state=0;
	mizshibuki[0].info_b=NULL;

	mizshibuki[1] = mizshibuki[0];

//Goodjob
	goodjob.cid		=pdat->cid;
	goodjob.type	=BULLETA_DISPZAHYO;
	goodjobcr[0]=941;
	goodjobcr[1]=-1;
	goodjobcd[0]=-1;
	goodjob.cell_run=goodjobcr;
	goodjob.cell_dis=goodjobcd;
	goodjob.spd_run	=1;
	goodjob.spd_dis	=1;
	goodjob.vx=0;
	goodjob.vy=0;
	goodjob.ax=goodjob.ay=0;
	goodjob.dur=100;
	goodjob.state=0;
	goodjob.info_b=NULL;

//ės@
	hikouki.cid		=pdat->cid;
	hikouki.type	=BULLETA_VSHUMAN | BULLETA_VSBULLET | BULLETA_DONOTDIE;
	hikoukicr[0]=945;
	hikoukicr[1]=946;
	hikoukicr[2]=-1;
	hikoukicd[0]=-1;
	hikouki.cell_run=hikoukicr;
	hikouki.cell_dis=hikoukicd;
	hikouki.spd_run	=1;
	hikouki.spd_dis	=1;
	hikouki.dur=90;
	hikouki.state=0;
	hikouki.info_b=NULL;


//ė̔s@
	hikoukina.cid		=pdat->cid;
	hikoukina.type	=0;
	hikoukinacr[0]=945;
	hikoukinacr[1]=946;
	hikoukinacr[2]=-1;
	hikoukinacd[0]=-1;
	hikoukina.cell_run=hikoukinacr;
	hikoukina.cell_dis=hikoukinacd;
	hikoukina.spd_run	=1;
	hikoukina.spd_dis	=1;
	hikoukina.dur=50;
	hikoukina.state=0;
	hikoukina.info_b=NULL;


//ėÕTC
	tsign.cid	=pdat->cid;
	tsign.type	=0;
	tsigncr[0]=1011;
	tsigncr[1]=-1;
	tsigncd[0]=-1;
	tsign.cell_run=tsigncr;
	tsign.cell_dis=tsigncd;
	tsign.spd_run	=1;
	tsign.spd_dis	=1;
	tsign.vx=0;
	tsign.vy=0;
	tsign.ax=tsign.ay=0;
	tsign.dur=40;
	tsign.state=0;
	tsign.info_b=NULL;

//j
	bakuha.cid		=pdat->cid;
	bakuha.type	=BULLETA_VSHUMAN | BULLETA_VSBULLET | BULLETA_DONOTDIE;
	bakuhacr[0]=949;
	bakuhacr[1]=950;
	bakuhacr[2]=951;
	bakuhacr[3]=952;
	bakuhacr[4]=953;
	bakuhacr[5]=954;
	bakuhacr[6]=955;
	bakuhacr[7]=-1;
	bakuhacd[0]=956;
	bakuhacd[1]=957;
	bakuhacd[2]=958;
	bakuhacd[3]=959;
	bakuhacd[4]=960;
	bakuhacd[5]=961;
	bakuhacd[6]=962;
	bakuhacd[7]=0;
	bakuhacd[8]=-1;
	bakuha.cell_run=bakuhacr;
	bakuha.cell_dis=bakuhacd;
	bakuha.spd_run	=3;
	bakuha.spd_dis	=2;
	bakuha.vx=0;
	bakuha.vy=0;
	bakuha.ax=bakuha.ay=0;
	bakuha.dur=25;
	bakuha.state=0;
	bakuha.info_b=NULL;

//g
	frame.cid		=pdat->cid;
	frame.type	=BULLETA_DISPZAHYO;
	framecr[0]=402;
	framecr[1]=-1;
	framecd[0]=-1;
	frame.cell_run=framecr;
	frame.cell_dis=framecd;
	frame.spd_run	=1;
	frame.spd_dis	=1;
	frame.vx=0;
	frame.vy=0;
	frame.ax=frame.ay=0;
	frame.dur=100;
	frame.state=0;
	frame.info_b=NULL;

//KAj[V
	animation.cid		=pdat->cid;
	animation.type	=BULLETA_DISPZAHYO;
	animationcr[0]=0;
	animationcr[1]=-1;
	animationcd[0]=-1;
	animation.cell_run=animationcr;
	animation.cell_dis=animationcd;
	animation.spd_run	=1;
	animation.spd_dis	=1;
	animation.vx=0;
	animation.vy=0;
	animation.ax=animation.ay=0;
	animation.dur=100;
	animation.state=0;
	animation.info_b=NULL;

//s@̋ѐ
	sakebi.cid		=pdat->cid;
	sakebi.type	=0;
	sakebicr[0]=332;
	sakebicr[1]=-1;
	sakebicd[0]=-1;
	sakebi.cell_run=sakebicr;
	sakebi.cell_dis=sakebicd;
	sakebi.spd_run	=1;
	sakebi.spd_dis	=1;
	sakebi.vx=-15;
	sakebi.vy=0;
	sakebi.ax=sakebi.ay=0;
	sakebi.dur=35;
	sakebi.state=0;
	sakebi.info_b=NULL;

//@˂
	tatakite.cid		=pdat->cid;
	tatakite.type	=BULLETA_DRAWBACK;
	tatakitecr[0]=947;
	tatakitecr[1]=948;
	tatakitecr[2]=-1;
	tatakitecd[0]=-1;
	tatakite.cell_run=tatakitecr;
	tatakite.cell_dis=tatakitecd;
	tatakite.spd_run	=5;
	tatakite.spd_dis	=1;
	tatakite.vx=-3;
	tatakite.vy=-8;
	tatakite.ax=0;
	tatakite.ay=-2;
	tatakite.dur=85;
	tatakite.state=0;
	tatakite.info_b=NULL;

//FD
	uniship.cid		=pdat->cid;
	uniship.type	=BULLETA_DISPZAHYO;
	unishipcr[0]=401;
	unishipcr[1]=-1;
	unishipcd[0]=-1;
	uniship.cell_run=unishipcr;
	uniship.cell_dis=unishipcd;
	uniship.spd_run	=1;
	uniship.spd_dis	=1;
	uniship.vx=-2;
	uniship.vy=0;
	uniship.ax=uniship.ay=0;
	uniship.dur=100;
	uniship.state=0;
	uniship.info_b=NULL;

//UFO
	ufo.cid		=pdat->cid;
	ufo.type	=BULLETA_DISPZAHYO;
	ufocr[0]=400;
	ufocr[1]=-1;
	ufocd[0]=-1;
	ufo.cell_run=ufocr;
	ufo.cell_dis=ufocd;
	ufo.spd_run	=1;
	ufo.spd_dis	=1;
	ufo.vx=0;
	ufo.vy=0;
	ufo.ax=ufo.ay=0;
	ufo.dur=100;
	ufo.state=0;
	ufo.info_b=NULL;

//Fsm
	pilot.cid		=pdat->cid;
	pilot.type	=BULLETA_DISPZAHYO;
	pilotcr[0]=395;
	pilotcr[1]=-1;
	pilotcd[0]=-1;
	pilot.cell_run=pilotcr;
	pilot.cell_dis=pilotcd;
	pilot.spd_run	=1;
	pilot.spd_dis	=1;
	pilot.vx=0;
	pilot.vy=0;
	pilot.ax=pilot.ay=0;
	pilot.dur=100;
	pilot.state=0;
	pilot.info_b=NULL;

//iCOMpZpj
	shigmadz.cid	=pdat->cid;
	shigmadz.type	=BULLETA_DISPZAHYO;
	shigmadzcr[0]=1011;
	shigmadzcr[1]=-1;
	shigmadzcd[0]=-1;
	shigmadz.cell_run=shigmadzcr;
	shigmadz.cell_dis=shigmadzcd;
	shigmadz.spd_run	=1;
	shigmadz.spd_dis	=1;
	shigmadz.vx=0;
	shigmadz.vy=0;
	shigmadz.ax=shigma.ay=0;
	shigmadz.dur=10;
	shigmadz.state=0;
	shigmadz.info_b=NULL;

//AvX
	arups.cid	=pdat->cid;
	arups.type	=0;
	arupscr[0]=1007;
	arupscr[1]=-1;
	arupscd[0]=-1;
	arups.cell_run=arupscr;
	arups.cell_dis=arupscd;
	arups.spd_run	=1;
	arups.spd_dis	=1;
	arups.vx=0;
	arups.vy=0;
	arups.ax=arups.ay=0;
	arups.dur=140;
	arups.state=0;
	arups.info_b=NULL;

//
	kokki.cid	=pdat->cid;
	kokki.type	=0;
	kokkicr[0]=1008;
	kokkicr[1]=1009;
	kokkicr[2]=1010;
	kokkicr[3]=-1;
	kokkicd[0]=-1;
	kokki.cell_run=kokkicr;
	kokki.cell_dis=kokkicd;
	kokki.spd_run	=3;
	kokki.spd_dis	=1;
	kokki.vx=0;
	kokki.vy=0;
	kokki.ax=kokki.ay=0;
	kokki.dur=140;
	kokki.state=0;
	kokki.info_b=NULL;


	WAZAINFO waz;
	ZeroMemory(&waz,sizeof(WAZAINFO));
	waz.walkf = ACTID_WALKF;
	waz.walkb = ACTID_WALKB;
	waz.jampf = ACTID_JAMPF;
	waz.jampb = ACTID_JAMPB;
	waz.dashf = ACTID_HIKKOMEO;
	waz.dashb = ACTID_HIKKOMEU;
//Z[`U
	waz.att_short[0] = ACTID_ATT_SB;
	waz.att_short[1] = ACTID_ATT_CB;
	waz.att_short[2] = ACTID_TAMAMUSHI1;
	waz.att_short[3] = ACTID_MIDGETL;
	waz.att_short[4] = ACTID_SHOWERC;
	waz.att_short[5] = ACTID_SHOWERJ;
//[`U
	waz.att_middle[0] = ACTID_ATT_SC;
	waz.att_middle[1] = ACTID_ATT_CC;
	waz.att_middle[2] = ACTID_SHOWERJ;
	waz.att_middle[3] = ACTID_SHOWERC;
	waz.att_middle[4] = ACTID_SHOWERS;
	waz.att_middle[5] = ACTID_TSUIRAKU;
//[`U
	waz.att_long[0] = ACTID_ATT_SS;
	waz.att_long[1] = ACTID_ATT_CS;
	waz.att_long[3] = ACTID_BUGGY2;
	waz.att_long[4] = ACTID_BUGGY3;
	waz.att_long[5] = ACTID_LJAMPS;
//WvU
	waz.att_jamp[0] = ACTID_KAMAITACHI1;
	waz.att_jamp[1] = ACTID_ATT_JS;
	waz.att_jamp[2] = ACTID_ATT_JC;
	waz.att_jamp[3] = ACTID_ATT_JB;
//	waz.att_jamp[4] = ;
//	waz.att_jamp[5] = ;
//΋
	waz.att_tai[0] = ACTID_ATT_CB;
	waz.att_tai[1] = ACTID_INHSHINRYU;
	waz.att_tai[2] = ACTID_ATT_SB;
	waz.att_tai[3] = ACTID_SHOWERS;
	waz.att_tai[4] = ACTID_ALPUS;
//	waz.att_tai[5] = ;
//ѓ
	waz.att_bullet[0] = ACTID_SHOWERC;
	waz.att_bullet[1] = ACTID_ALPUS;
//	waz.att_bullet[2] = ;
//	waz.att_bullet[3] = ;
//	waz.att_bullet[4] = ;
//	waz.att_bullet[5] = ;
	(*pdat->fpack->pf_setwazainfo)(pdat->cid,&waz);
}

CCharacter::~CCharacter()
{
}

void CCharacter::InitChar()
{
	hachires=0;
	wect=0;
	daresan=0;
	tamed=0;
	atariauto=0;
	chakuchip=0;
	cpu=0;
	SbeforeB=0;
	SbeforeA=0;
	stockbf=0;
	AbeforeB=0;
	AbeforeA=0;
	stockaf=0;
	buggycrs=0;
	sanadacrs=0;
	aircheck=0;
	showerlimit=0;
	showertype=0;
//܂蔭ɔϐ
	mtamarinow=0;
	mtamaricounter=0;
	fsthmaai=0;
	hmaaikettei=0;
	mizuichi=0;
	mizukettei=0;
	emwksa=0;
	mizkyori=0;
	mzsearch=0;
	tysearch=0;
	ejswitch=0;
	ysa=0;
	tamayurecount=0;
	shibuagecounte=0;
	shibuagecounts=0;
	amembo=0;
	emuki=0;
//܂
	shinryuroad=0;
	jumpshiru=0;
	jumpshite=0;
	shinryucounter=0;
	shinryuhit=0;
	gjcounter=0;
	mochiketsu=0;
	otoshibotan=0;
	noburnd=0;
	fririku=0;
	kwhere=0;
	ttkwait=0;
	rn=5;
	rncounter=0;
	trrcounter=0;
	alwin=0;
	alwinera=0;
	knah=0;
	knav=0;
	knbh=0;
	knbv=0;
	tiah=0;
	tiav=0;

	CHARACTERINFO3 info;
	ZeroMemory(&info,sizeof(CHARACTERINFO3));
	info.hpmax = 1050;
	info.pgauge = CINFO3_POWGAUGE2;
	info.pgaugemax = 1;
	info.ppgauge_guard = 0.02;
	info.ppgauge_hit = 0.01;
	(*pdat->fpack->pf_setcharinfo3)(pdat->cid,&info);
}

void CCharacter::Command()
{
	DWORD key_now = pdat->fpack->pf_getkey(pdat->cid,0);
	(*pdat->fpack->pf_getmaai)(pdat->cid,&hm,&vm,&eaid);

	//ߊ֘A
	if(key_now & KEYSTA_DOWN){
		if(pdat->aid & ACTID_KUCYU){//󒆂̂݃^\BłȂƃ[Wv̂ƏdȂĂ܂B
			if(tamed<20)tamed++;
			else{tamed--;if(tamed<0)tamed=0;}
		}
	}
	//ߊ֘A


	if(pdat->muki == 0){amembom=1;emuki=0;}//amemboɂďɂtɂ
	else {amembom=-1;emuki=1;}//ifpdat->muki == 0pdat->muki == pdat->mukiƂƁA肪ƐԂɉeȂȂB

	if(wect==1){
		if(pdat->aid != ACTID_TOJYO){//ɔ8gEhŏĂȂƂ̏
			if(htoushin.state!=0){//8g̏ꍇ
				if(htoushin.y<0){
					htoushincr[0]=htoushincr[1]=htoushincr[2]=376;
				}
				if(htoushin.y<=0){//nʂɂ߂荞łȂ̒n܂
					htoushin.vy+=2;
				}
				else if(htoushin.y>0){
					htoushin.spd_run=2;
					htoushin.muki	= pdat->muki==0 ? 1 : 0;
					htoushin.ay=0;
					htoushin.vy=0;
					htoushin.y=0;
					htoushin.vx=15;
					htoushincr[0]=372;
					htoushincr[1]=373;
					htoushincr[2]=374;
				}
			}
			if(onigiri.state!=0){//8g̏ꍇ
				if(onigiri.y<0){
					onigiricr[0]=onigiricr[1]=367;
				}
				if(onigiri.y<=0){//nʂɂ߂荞łȂ̒n܂
					onigiri.vy+=1;
				}
				else if(onigiri.y>0){
					onigiri.muki	= pdat->muki==0 ? 1 : 0;
					onigiri.ay=0;
					onigiri.vy=0;
					onigiri.y=0;
					onigiri.vx=15;
					onigiricr[0]=367;
					onigiricr[1]=368;
				}
			}
			if(ichisan.state!=0){//1̏ꍇ
				if(ichisan.y<0){
					ichisancr[0]=ichisancr[1]=ichisancr[2]=356;
				}
				if(ichisan.y<=0){//nʂɂ߂荞łȂ̒n܂
					ichisan.vy+=1;
				}
				else if(ichisan.y>0){
					ichisan.spd_run=3;
					ichisan.muki	= pdat->muki==0 ? 1 : 0;
					ichisan.ay=0;
					ichisan.vy=0;
					ichisan.y=0;
					ichisan.vx=15;
					ichisancr[0]=353;
					ichisancr[1]=354;
					ichisancr[2]=355;
				}
			}
		}
		if(htoushin.state==0 && onigiri.state==0 && ichisan.state==0){wect=0;}//Ă0ɁB
	}
	if(pdat->aid & ACTID_SYSTEM){//H炢ȂǂSbeforeBȂǂfꂽƂAł炩ɂ邽߂SbeforeBȂǂʂ
		if(pdat->aid & ACTID_KUCYU){
			AbeforeB=0;
			AbeforeA=0;
			stockaf=0;
		}
		SbeforeB=0;
		SbeforeA=0;
		stockbf=0;
		chakuchip=0;
	}
	if(pdat->y == 0){
		if(aircheck == 1)aircheck=0;
		if(tamed != 0)tamed=0;
	}
	ysa = pdat->y + vm;//0Ȃ瑊肪nʂɂĂƁB܂̂ق128gɂgB

//ȏ͖̂AƂ̊ԍi̎iȂj̓Ő܂萅Ԃo@B
//͂̐܂ƐԂ̃VXeǁA128̈ړŃXN[Đ܂̂ꂪ~܂Ȃ̂ƁAړj[gɖ߂ĂԂȂǂ߂炸Wv܂ŏIȂoOi̗͂ł́jłȂ܂܂łĂB
///////////////////////////////////////////////////////////////////////////////
////////////////////////////܂ɂĂ͂/////////////////////////
///////////////////////////////////////////////////////////////////////////////
	if(mtamarinow==1){//V[Ő܂ĂۂɐHK[ĥƂ
		if(pdat->aid != ACTID_SHOWERJ && pdat->aid != ACTID_SHOWERS
		 && pdat->aid != ACTID_SHOWERC && pdat->aid != ACTID_SHOWERF){
			if(miztamari.state==0){
				miztamari.muki=pdat->muki;
				miztamari.x	=pdat->x;
				miztamari.y	=0;
				miztamari.dur=800;
				(*pdat->fpack->pf_gobulleta)(&miztamari);
			}
			mtamarinow=0;
		}
	}
	if(miztamari.state!=0){//܂蔭

		mtamaricounter++;
		if(mtamaricounter==0){
			miztamari.spd_run=2;
		}
		if(mtamaricounter==4){
			mizkyori=1;
			miztamaricr[0]=896;
			miztamaricr[1]=896;
			miztamaricr[2]=896;
		}
		if(mtamaricounter==7){
			mizkyori=2;
			miztamaricr[0]=897;
			miztamaricr[1]=897;
			miztamaricr[2]=897;
		}
		if(mtamaricounter==12){
			mizkyori=3;
			miztamaricr[0]=898;
			miztamaricr[1]=898;
			miztamaricr[2]=898;
		}
		if(mtamaricounter==18 && tamayurecount==0){
			miztamaricr[0]=899;
			miztamaricr[1]=900;
			miztamaricr[2]=898;
		}
		if(mtamaricounter>=30 && tamayurecount==0){
			miztamaricr[0]=898;
			miztamaricr[1]=898;
			miztamaricr[2]=898;
		}

		if( (pdat->x <= miztamari.x + 40*mizkyori) && (pdat->x >= miztamari.x - 40*mizkyori) ){//܂ɋ߂ÂƂ
			if(pdat->aid & ACTID_SYSTEM){
				if(pdat->vy!=0){
					if(mizshibuki[0].state==0)shibuagecounts=7;
					if(mizkyori==3)tamayurecount=12;
				}
			}
			if(pdat->y==0){
				if(amembo!=0){
					if(mizshibuki[0].state==0)shibuagecounts=7;
					if(mizkyori==3)tamayurecount=12;
				}
			}
			else if(pdat->y > 0){
				if(mizshibuki[0].state==0)shibuagecounts=7;
				if(mizkyori==3)tamayurecount=12;
			}
		}

		if(hmaaikettei==0){//ŏɎƑƂ̊ԍc
			if(emuki==0)fsthmaai=pdat->x + hm;
			else fsthmaai=pdat->x - hm;
			hmaaikettei=1;
		}
		if(mizukettei==0){//ŏ̐܂ʒu
			mizuichi=miztamari.x;
			mizukettei=1;
		}

		//̋mĐ܂ɗĂ邩ǂ
		if(emuki==0){
			if( (pdat->x+hm >= miztamari.x - 40*mizkyori) && (pdat->x+hm <= miztamari.x + 40*mizkyori) ){
				if(ysa==0){//Ƒ͒nʂɂ邩
					mzsearch=1;//1ł͂łON
				}
				else mzsearch=0;//ȂΒnʂɂȂƂ݂ȂAOFFɖ߂
			}
			else mzsearch=0;
		}
		else if(emuki==1){
//̂悤ɁApdat->x+hmpdat->x-hmɕ򂵂킯́Äʒu}pdat->x+hmƉE}pdat->x-hm
//pdat->x+hm*ϐłP܂Ƃ߂ĂA̕ϐ-ɂĂE͐}ꂸ͂Ȃ߁B
			if( (pdat->x-hm >= miztamari.x - 40*mizkyori) && (pdat->x-hm <= miztamari.x + 40*mizkyori) ){
				if(ysa==0){//Ƒ͒nʂɂ邩
					mzsearch=1;//1ł͂łON
					ejswitch=1;
				}
				else{mzsearch=0;ejswitch=0;}//ȂΒnʂɂȂƂ݂ȂAOFFɖ߂
			}
			else{mzsearch=0;ejswitch=0;}
		}

		if(emwksa != fsthmaai-mizuichi){
			if(mzsearch==1){
				tamayurecount=12;
				if(mizshibuki[1].state==0)shibuagecounte=7;
			}
		}
		emwksa = fsthmaai-mizuichi;
		if(emuki==0)fsthmaai=pdat->x + hm;
		else fsthmaai=pdat->x - hm;
		mizuichi=miztamari.x;

		if(mzsearch==1){//͂Ɛ܂ɂ
			if(ysa>0){//ɂ炸WvȂǂō
				if(mizkyori==3)tamayurecount=12;
				if(mizshibuki[1].state==0)shibuagecounte=7;
			}
		}
		else if(mzsearch==0){//肪܂ɂ͂Ȃ
			if(ysa<0 && ejswitch==1){//肪Wvny==0߂肱ޖ͗l
				if(emuki==0){
					if((pdat->x+hm <= miztamari.x + 40*mizkyori) && (pdat->x+hm >= miztamari.x - 40*mizkyori) ){//܂葊͐܂ɒn
						if(mizkyori==3)tamayurecount=12;
						if(mizshibuki[1].state==0)shibuagecounte=7;
					}
				}
				else if(emuki==1){
					if((pdat->x-hm <= miztamari.x + 40*mizkyori) && (pdat->x-hm >= miztamari.x - 40*mizkyori) ){//܂葊͐܂ɒn
						if(mizkyori==3)tamayurecount=12;
						if(mizshibuki[1].state==0)shibuagecounte=7;
					}
				}
			}
		}

		if(mizshibuki[0].state==0){
		if(shibuagecounts==7){//Ԃíj̃JEgŒ
			if(pdat->aid & ACTID_SYSTEM && pdat->vy > 0){//H炢Ȃǂ̃VXeŋtɑĂ
				mizshibuki[0].muki = 1;
				mizshibuki[0].x	=pdat->x+30;
				mizshibuki[0].vx=2;
				mizshibuki[0].dur=7;
				(*pdat->fpack->pf_gobulleta)(&mizshibuki[0]);
			}
			else if(pdat->aid & ACTID_SYSTEM && pdat->vy < 0){//H炢Ȃǂ̃VXeŏɑ0
				mizshibuki[0].muki = 0;
				mizshibuki[0].x	=pdat->x-30;
				mizshibuki[0].vx=-2;
				mizshibuki[0].dur=7;
				(*pdat->fpack->pf_gobulleta)(&mizshibuki[0]);
			}
			if(pdat->vx <= 0){//ʏsŋtɑĂ
				mizshibuki[0].muki = 1;
				mizshibuki[0].x	=pdat->x+30;
				mizshibuki[0].vx=2;
				mizshibuki[0].dur=7;
				(*pdat->fpack->pf_gobulleta)(&mizshibuki[0]);
			}
			else if(pdat->vx > 0){//ʏsŏɑ0
				mizshibuki[0].muki = 0;
				mizshibuki[0].x	=pdat->x-30;
				mizshibuki[0].vx=-2;
				mizshibuki[0].dur=7;
				(*pdat->fpack->pf_gobulleta)(&mizshibuki[0]);
			}
		}
		}
		if(mizshibuki[1].state==0){
		if(shibuagecounte==7){//Ԃi葤́j̃JEgŒ
			if(emuki==0){
				if(pdat->x+hm <= fsthmaai){//鑊ʒu0͓
					mizshibuki[1].muki = 1;
					mizshibuki[1].x	=pdat->x+hm+30;
					mizshibuki[1].vx=2;
					mizshibuki[1].dur=7;
					(*pdat->fpack->pf_gobulleta)(&mizshibuki[1]);
				}
				else {//鑊ʒu
					mizshibuki[1].muki = 0;
					mizshibuki[1].x	=pdat->x+hm+70;
					mizshibuki[1].vx=-2;
					mizshibuki[1].dur=7;
					(*pdat->fpack->pf_gobulleta)(&mizshibuki[1]);
				}
			}
			if(emuki==1){
				if(pdat->x-hm <= fsthmaai){//鑊ʒu0͓
					mizshibuki[1].muki = 0;
					mizshibuki[1].x	=pdat->x-hm-70;
					mizshibuki[1].vx=-2;
					mizshibuki[1].dur=7;
					(*pdat->fpack->pf_gobulleta)(&mizshibuki[1]);
				}
				else {//鑊ʒu
					mizshibuki[1].muki = 1;
					mizshibuki[1].x	=pdat->x-hm-30;
					mizshibuki[1].vx=2;
					mizshibuki[1].dur=7;
					(*pdat->fpack->pf_gobulleta)(&mizshibuki[1]);
				}
			}
		}
		}
		if(tamayurecount==12){//܂̃JEgŒ
			miztamaricr[0]=898;
			miztamaricr[1]=899;
			miztamaricr[2]=900;
			miztamari.spd_run	=2;
			}
		if(tamayurecount!=0){//܂肪ĂŒ
			tamayurecount--;
		}
		if(shibuagecounts!=0){//ԂijĂŒ
			shibuagecounts--;
		}
		if(shibuagecounte!=0){//Ԃi葤jĂŒ
			shibuagecounte--;
		}
	}

	if(miztamari.state==0){//܂肪̐܂pJE^[Ȃǂʂ
		mtamaricounter=0;
		fsthmaai=0;
		hmaaikettei=0;
		mizuichi=0;
		mizukettei=0;
		emwksa=0;
		mizkyori=0;
		mzsearch=0;
		tysearch=0;
		ejswitch=0;
		tamayurecount=0;
		shibuagecounte=0;
		shibuagecounts=0;
	}
///////////////////////////////////////////////////////////////////////////////
/////////////////////܂ɂĂ͂܂////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

	if(shinryuhit>=18){//128gQOqbgȏサƂ
		if(goodjob.state==0){
			goodjob.muki=0;
			if(pdat->cid == 0){
				goodjob.x	=639;
				goodjob.vx	=-11;
			}
			else if(pdat->cid == 1){
				goodjob.x	=0;
				goodjob.vx	=11;
			}
			goodjob.y	=135;
			goodjob.dur=100;
			(*pdat->fpack->pf_gobulleta)(&goodjob);
		}
		shinryuhit=0;
	}
	if(goodjob.state!=0){
		gjcounter++;
		if(gjcounter==10)goodjobcr[0]=942;
		if(gjcounter==17)goodjobcr[0]=943;
		if(gjcounter==25)goodjobcr[0]=944;
		if(pdat->cid == 0){
			if(goodjob.x < 140){
				goodjob.x=140;
				goodjob.vx=0;
			}
		}
		else if(pdat->cid == 1){
			if(goodjob.x > 470){
				goodjob.x=470;
				goodjob.vx=0;
			}
		}
	}
	else gjcounter=0;

	if(hikoukina.state!=0){
		if(pdat->aid != ACTID_TSUIRAKU){
			hikoukina.y=hikoukina.vy=hikoukina.ay=0;
		}
	}
	if(alwin==1){if(pdat->hp<=0)alwin=0;}

	if(pdat->aid & ACTID_SYSTEM){//VXe`쒆Ȃ̂ŁA{Iɂ͂Ȃ
		//K[hLZ
		if(pdat->aid & ACTID_GUARD && !(pdat->aid & ACTID_KUCYU) && (pdat->gauge >= 0.2)){//K[hLZ
			if(com426(30)){
				if(key_now & KEYSTA_BC2){pdat->aid = ACTID_MIDGETL;pdat->gauge-=0.2;return;}
			}
		}
		amembo=0;//H炢Ȃǂ̃VXeamembo0ɂĂB
		return;
	}
	if(pdat->aid == ACTID_TOJYO || pdat->aid==ACTID_SYORI)return;
	if(pdat->aid & ACTID_NAGE){
		if(pdat->aid == ACTID_NOBINAGE){
			if(pdat->counter >=1 && pdat->counter <= 80 + 4 + 123 + 10 + 70 - 1){//{^ɂČB
				if(key_now & KEYSTA_BA2)otoshibotan=1;
				if(key_now & KEYSTA_BB2)otoshibotan=2;
				if(key_now & KEYSTA_BC2)otoshibotan=3;
				if(key_now & KEYSTA_BD2)otoshibotan=4;
			}
		}
		return;
	}
	
	if(pdat->aid & ACTID_HISSATU){//KEZi{Iɂׂ炸j
		if(pdat->aid == ACTID_LJAMPS){//character.hɂĂ[WvKEZɂBʏZAƂWv̍sDʂɂĂWv̕D悳Ă܂߁B
			if(key_now & KEYSTA_FOWORD){//O[Wv
				pdat->aid = ACTID_LJAMPF;
				return;
			}
			else if(key_now & KEYSTA_BACK){//ネ[Wv
				pdat->aid = ACTID_LJAMPB;
				return;
			}
		}
		if(pdat->aid == ACTID_TSUIRAKU){
			if(pdat->counter >=1 && pdat->counter <= 70 + 4 + 115 + 10 - 1){//{^ɂČB
				if(key_now & KEYSTA_BA2)otoshibotan=1;
				if(key_now & KEYSTA_BB2)otoshibotan=2;
				if(key_now & KEYSTA_BC2)otoshibotan=3;
				if(key_now & KEYSTA_BD2)otoshibotan=4;
			}
		}
		if(pdat->aid == ACTID_LJAMPS){
				if(key_now & KEYSTA_BA2)otoshibotan+=1;
				if(key_now & KEYSTA_BB2)otoshibotan-=1;
		}
		return;
	}

	//KEZR}h
	if(pdat->aid & ACTID_KUCYU){
		if(itachi.state==0)if(com486(40)){
			if(key_now & KEYSTA_BC2){pdat->aid = ACTID_KAMAITACHI3;return;}
			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_KAMAITACHI2;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_KAMAITACHI1;return;}
		}
	}
	else{
		if((com236426(60))&&(pdat->gauge>=1)){
			if(key_now & KEYSTA_BB2){pdat->aid = ACTID_INHSHINRYU;return;}
		}
		if((com64628(60))&&(pdat->gauge>=1)){
			if(key_now & KEYSTA_BA2){pdat->aid = ACTID_TSUIRAKU;return;}
		}
		if((com21426(60))&&(com_nage(60))&&(pdat->gauge>=1)){
			if(key_now & KEYSTA_BC2){
				if(pdat->cid==0){cy.pf_nagerare = gf_Nobin1;}
				else {cy.pf_nagerare = gf_Nobin2;}
				if((*pdat->fpack->pf_catchenemy)(pdat->cid,&cy)){
					pdat->aid = ACTID_NOBINAGE;return;
				}
			}
		}

		if(com236236(35)){
			if(key_now & KEYSTA_BC2){pdat->aid = ACTID_BUGGY3;return;}
			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_BUGGY2;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_BUGGY1;return;}
		}
		if(com214214(35)){
			if(key_now & KEYSTA_BC2){pdat->aid = ACTID_TAMAMUSHI3;return;}
			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_TAMAMUSHI2;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_TAMAMUSHI1;return;}
		}
		if(com624(35)){
			if(flood.state==0 && fatack[0].state==0 &&fatack[1].state==0){//^͂oȂ悤
				if(key_now & KEYSTA_BC2){pdat->aid = ACTID_SHOWERC;return;}
				else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_SHOWERS;return;}
				else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_SHOWERJ;return;}
			}
		}
	}

	if(pdat->aid & ACTID_ATTACK){//U쒆i{IɂȂB`F[R{oȂ炱łj
		if(pdat->aid & ACTID_KUCYU){////Wv쒆
			/*
			DWORD hm,vm,eaid;
			(*pdat->fpack->pf_getmaai)(pdat->cid,&hm,&vm,&eaid);
				//GASŁi`FCXgɈxo^ꂽZ̓LZoȂj
				if(key_now & 0x22220000){
					if(key_now & KEYSTA_BC2){if(ChainCombo(CHAIN_JS)){pdat->aid = ACTID_ATT_JS;return;}}
					else if(key_now & KEYSTA_BB2){if(ChainCombo(CHAIN_JC)){pdat->aid = ACTID_ATT_JC;return;}}
					else if(key_now & KEYSTA_BA2){if(ChainCombo(CHAIN_JB)){pdat->aid = ACTID_ATT_JB;return;}}
				}
			return;
			*/
		}
		else{
			if(com66(20) && !(pdat->aid & ACTID_ATTACK)){if(ChainCombo(CHAIN_HIKKOMEO)){pdat->aid = ACTID_HIKKOMEO;return;}}
			if(com44(20) && !(pdat->aid & ACTID_ATTACK)){if(ChainCombo(CHAIN_HIKKOMEU)){pdat->aid = ACTID_HIKKOMEU;return;}}
			if(key_now & 0x22220000){
				if(key_now & KEYSTA_DOWN){
					if(key_now & KEYSTA_BC2){if(ChainCombo(CHAIN_CS)){pdat->aid = ACTID_ATT_CS;return;}}
					else if(key_now & KEYSTA_BB2){if(ChainCombo(CHAIN_CC)){pdat->aid = ACTID_ATT_CC;return;}}
					else if(key_now & KEYSTA_BA2){if(ChainCombo(CHAIN_CB)){pdat->aid = ACTID_ATT_CB;return;}}
				}
				else{
					if(key_now & KEYSTA_BC2){if(ChainCombo(CHAIN_SS)){pdat->aid = ACTID_ATT_SS;return;}}
					else if(key_now & KEYSTA_BB2){if(ChainCombo(CHAIN_SC)){pdat->aid = ACTID_ATT_SC;return;}}
					else if(key_now & KEYSTA_BA2){if(ChainCombo(CHAIN_SB)){pdat->aid = ACTID_ATT_SB;return;}}
				}
			}
		}
		return;
	}

	if(pdat->aid & ACTID_KUCYU){//Wv쒆
		if((tamed>15) && (key_now & KEYSTA_UP) && aircheck==0){
			pdat->aid = ACTID_FUYUU;aircheck=1;return;}
		if(key_now & 0x22220000){
			if(key_now & KEYSTA_BC2){pdat->aid = ACTID_ATT_JS;return;}
			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_ATT_JC;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_ATT_JB;return;}
		}
		return;
	}

	//{쒆
	if(key_now & 0x22220000){
		if(key_now & KEYSTA_DOWN){
			if(key_now & KEYSTA_BC2){pdat->aid = ACTID_ATT_CS;return;}
			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_ATT_CC;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_ATT_CB;return;}
		}
		else{
			if(key_now & KEYSTA_BC2){
				if(key_now & KEYSTA_FOWORD){
					if(com_nage(45)){//4045ɂ邱Ƃŏ]LLԍ
						if(pdat->cid==0){cy.pf_nagerare = gf_Nage1;}
						else {cy.pf_nagerare = gf_Nage2;}
						if((*pdat->fpack->pf_catchenemy)(pdat->cid,&cy)){
							pdat->aid = ACTID_NAGE1;return;
						}
					}
				}
				pdat->aid = ACTID_ATT_SS;return;
			}

			else if(key_now & KEYSTA_BB2){pdat->aid = ACTID_ATT_SC;return;}
			else if(key_now & KEYSTA_BA2){pdat->aid = ACTID_ATT_SB;return;}
		}
	}

	if(pdat->aid == ACTID_JAMPS){
		if(key_now & KEYSTA_FOWORD){//OWv
			pdat->aid = ACTID_JAMPF;
			return;
		}
		else if(key_now & KEYSTA_BACK){//Wv
			pdat->aid = ACTID_JAMPB;
			return;
		}
	}
	if(com66(20)){pdat->aid = ACTID_HIKKOMEO;return;}
	if(com44(20)){pdat->aid = ACTID_HIKKOMEU;return;}


	if((pdat->aid == ACTID_CROUCH) && pdat->counter < 5){
		if(key_now & KEYSTA_UP){
			pdat->aid = ACTID_LJAMPS;
		}
	}
	else if(key_now & KEYSTA_UP){
		pdat->aid = ACTID_JAMPS;
	}
	else if(key_now & KEYSTA_DOWN){//Ⴊ
		pdat->aid = ACTID_CROUCH;
	}
	else if(key_now & KEYSTA_FOWORD){//O
		if(pdat->aid==ACTID_HIKKOMEO)return;
		pdat->aid = ACTID_WALKF;
	}
	else if(key_now & KEYSTA_BACK){//
		if(pdat->aid==ACTID_HIKKOMEU)return;
		pdat->aid = ACTID_WALKB;
	}
	else{//j[g|[Y
		if(chakuchip==1)pdat->aid = ACTID_CHAKUCHI;
		else pdat->aid = ACTID_NEUTRAL;
	}
}

BOOL CCharacter::CommandCOM(DWORD wid)
{
	cpu=1;//ł̑cpuCOMƎ̂邱ƁI
		//=0Ə0ɂȂĂ܂̂ŁA
		//Ⴆnoburnd=0ƂƁAs@Ăjs@Ȃ݂̃_[Ŵ܂܂ɂȂ肷B
		//=1ꂽƂĂAnoburnd=0ƁA=0ƂȂ邽߁B
		//0͂ƂCOMp̐łAInitChar0΂B

	(*pdat->fpack->pf_getmaai)(pdat->cid,&hm,&vm,&eaid);
	ysa = pdat->y + vm;//0Ȃ瑊肪nʂɂĂƁB܂̂ق128gɂgB

	if(pdat->aid & ACTID_SYSTEM){//H炢ȂǂSbeforeBȂǂfꂽƂAł炩ɂ邽߂SbeforeBȂǂʂ
		if(pdat->aid & ACTID_KUCYU){
			AbeforeB=0;
			AbeforeA=0;
			stockaf=0;
		}
		SbeforeB=0;
		SbeforeA=0;
		stockbf=0;
		chakuchip=0;
	}
	if(pdat->y == 0)aircheck = 0;

	if(hikoukina.state!=0){
		if(pdat->aid != ACTID_TSUIRAKU){
			hikouki.ax=0.4;//ꂾł͔s@ȂA܂ɓƂ邽߃vOƂ݂ȂAhikouki.vyȂĂƂB
			hikoukina.y=hikoukina.vy=hikoukina.ay=0;
		}
	}
	if(alwin==1){if(pdat->hp<=0)alwin=0;}

	if(((pdat->aid==ACTID_LJAMPC)||(pdat->aid==ACTID_JAMPC)) && pdat->counter<5)return(FALSE);

	if(wid==ACTID_MIDGETL){if(!(pdat->aid & ACTID_SYSTEM))return(FALSE);}//K[LȊOł͎g킹Ȃ
	if((wid==ACTID_INHSHINRYU)&&(pdat->gauge<1.0))return(FALSE);
	if((wid==ACTID_TSUIRAKU)&&(pdat->gauge<1.0))return(FALSE);
	if(wid == ACTID_ALPUS){if((pdat->gauge <1.0) || (!(pdat->hp < 350)))return(FALSE);}
	//肪UłȂ瓖gȂ
	DWORD hm,vm,eaid;
	(*pdat->fpack->pf_getmaai)(pdat->cid,&hm,&vm,&eaid);
	if(!(eaid & ACTID_ATTACK)){
		if(wid==ACTID_SHOWERJ || wid==ACTID_SHOWERS || wid==ACTID_SHOWERC)return(FALSE);
	}

	if(pdat->aid & ACTID_SYSTEM){
		if(pdat->aid & ACTID_GUARD && !(pdat->aid & ACTID_KUCYU) && (pdat->gauge >= 0.7)){//K[L
			if(wid==ACTID_MIDGETL){pdat->gauge-=0.2;return(TRUE);}
		}
		return(FALSE);
	}
	if(pdat->aid == ACTID_TOJYO || pdat->aid==ACTID_SYORI)return(FALSE);
	if(pdat->aid & ACTID_NAGE)return(FALSE);

	if(pdat->aid & ACTID_HISSATU){//KEZi{Iɂׂ炸j
		return(FALSE);
	}

	if(pdat->aid & ACTID_KUCYU){
		if(pdat->aid & ACTID_ATTACK){//󒆍U
			if(wid&ACTID_HISSATU && wid&ACTID_KUCYU)return(TRUE);//󒆕KEZȂOK
			return(FALSE);//ȊO͂
		}
		else{//󒆒ʏ퓮쒆
			if(wid&ACTID_ATTACK && wid&ACTID_KUCYU)return(TRUE);//󒆒ʏZȂOK
			return(FALSE);//ȊO͂
		}
	}
	else{
		if(pdat->aid & ACTID_ATTACK){//nU
			if(wid&ACTID_HISSATU && !(wid&ACTID_KUCYU))return(TRUE);//nKEZȂOK
			//яオZ
			if(wid==ACTID_TSUIRAKU)return(TRUE);
			if(wid==ACTID_ALPUS)return(TRUE);
			return(FALSE);//ȊO͂
		}
		else{//nʏ퓮
			if(wid&ACTID_KUCYU && wid&ACTID_ATTACK)return(FALSE);//󒆍U͂
			if(wid==ACTID_TSUIRAKU)return(TRUE);
			if(wid==ACTID_ALPUS)return(TRUE);
			return(TRUE);//ȊOȂOK
		}
	}
}

void CCharacter::Action()
{
	if(!(pdat->aid & 0xFFFD0000)){
		(*(pdat->fpack->pf_furimuki))(pdat->cid);
		chainlist=0;
	}

	switch(pdat->aid){
	case ACTID_NEUTRAL	:act_neutral();break;//default actions
	case ACTID_CROUCH	:act_crouch();break;
	case ACTID_RAKKA	:act_rakka();break;
	case ACTID_TOJYO	:act_tojyo();break;
	case ACTID_SYORI	:act_win();break;
	case ACTID_WALKF	:act_walkf();break;//normal actions
	case ACTID_WALKB	:act_walkb();break;
	case ACTID_CHAKUCHI	:act_chakuchi();break;
	case ACTID_JAMPS	:act_jamps();break;
	case ACTID_JAMPC	:act_jampc();break;
	case ACTID_JAMPF	:act_jampf();break;
	case ACTID_JAMPB	:act_jampb();break;
	case ACTID_LJAMPS	:act_ljamps();break;
	case ACTID_LJAMPC	:act_ljampc();break;
	case ACTID_LJAMPF	:act_ljampf();break;
	case ACTID_LJAMPB	:act_ljampb();break;
	case ACTID_FUYUU	:act_fuyuu();break;
	case ACTID_ATT_SB	:act_att_sb();ChainCombo(CHAIN_SB);break;//attack actions
	case ACTID_ATT_SC	:act_att_sc();ChainCombo(CHAIN_SC);break;
	case ACTID_ATT_SS	:act_att_ss();ChainCombo(CHAIN_SS);break;
	case ACTID_ATT_CB	:act_att_cb();ChainCombo(CHAIN_CB);break;
	case ACTID_ATT_CC	:act_att_cc();ChainCombo(CHAIN_CC);break;
	case ACTID_ATT_CS	:act_att_cs();ChainCombo(CHAIN_CS);break;
	case ACTID_ATT_JB	:act_att_jb();ChainCombo(CHAIN_JB);break;
	case ACTID_ATT_JC	:act_att_jc();ChainCombo(CHAIN_JC);break;
	case ACTID_ATT_JS	:act_att_js();ChainCombo(CHAIN_JS);break;
	case ACTID_KAMAITACHI1	:act_kamaitachi1();break;
	case ACTID_KAMAITACHI2	:act_kamaitachi2();break;
	case ACTID_KAMAITACHI3	:act_kamaitachi3();break;
	case ACTID_MIDGETL	:act_midgetl();break;
	case ACTID_BUGGY1	:act_buggy1();break;
	case ACTID_BUGGY2	:act_buggy2();break;
	case ACTID_BUGGY3	:act_buggy3();break;
	case ACTID_TAMAMUSHI1	:act_tamamushi1();break;
	case ACTID_TAMAMUSHI2	:act_tamamushi2();break;
	case ACTID_TAMAMUSHI3	:act_tamamushi3();break;
	case ACTID_SHOWERJ	:act_showerj();break;
	case ACTID_SHOWERS	:act_showers();break;
	case ACTID_SHOWERC	:act_showerc();break;
	case ACTID_SHOWERF	:act_showerf();break;
	case ACTID_INHSHINRYU	:act_inhshinryu();break;
	case ACTID_TSUIRAKU	:act_tsuiraku();break;
	case ACTID_NOBINAGE	:act_nobinage();break;
	case ACTID_CHOUHICH	:act_chouhich();break;;
	case ACTID_ALPUS	:act_blizzard();break;
	case ACTID_HIKKOMEO	:act_hikkomeo();break;
	case ACTID_HIKKOMEU	:act_hikkomeu();break;
	case ACTID_NAGE1	:act_nage();break;

	}
}

DWORD CCharacter::TouchA(ATTACKINFO *info)
{
	DWORD key_now = pdat->fpack->pf_getkey(pdat->cid,0);


	if(pdat->aid==ACTID_ATT_CS){//XCfBOɐHƂ
		if(sand.state != 0){
			sand.vx	=-5;//nʂȂȂ̂ŁA͌
			return(TOUCHA_KURAIC);
		}
	}
	if(pdat->aid==ACTID_MIDGETL){
		if((pdat->counter >=0) && (pdat->counter <=12)){
			return(TOUCHA_MUSI2);
		}
	}
	//gZ@SHOWERJ͏i@S͒i@C͉i
	if(pdat->aid == ACTID_SHOWERJ && showerlimit==0){
		if(info->guard & GUARDINFO_XCROUCH){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if(info->guard & GUARDINFO_XSTAND){
			return(TOUCHA_GUARDS);
		}
		else if(info->guard & GUARDINFO_XJAMP){
			return(TOUCHA_KURAIS);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH)){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if((info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_KURAIS);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_GUARDS);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_KURAIS);
		}
		else{

			if(atariauto == 0){pdat->aid = ACTID_SHOWERF;return(0);}
			else if(atariauto == 1){return(TOUCHA_GUARDS);}
			else {return(TOUCHA_KURAIS);}
		}
	}
	if(pdat->aid == ACTID_SHOWERS && showerlimit==0){
		if(info->guard & GUARDINFO_XCROUCH){
			return(TOUCHA_GUARDS);
		}
		else if(info->guard & GUARDINFO_XSTAND){
			return(TOUCHA_KURAIS);
		}
		else if(info->guard & GUARDINFO_XJAMP){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH)){
			return(TOUCHA_GUARDS);
		}
		else if((info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XJAMP)){//ႪݍUɑ΂
			return(TOUCHA_KURAIS);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_KURAIS);
		}
		else{
			if(atariauto == 0){return(TOUCHA_GUARDS);}
			else if(atariauto == 1){return(TOUCHA_KURAIS);}
			else {pdat->aid = ACTID_SHOWERF;return(0);}
		}
	}
	if(pdat->aid == ACTID_SHOWERC && showerlimit==0){
		if(info->guard & GUARDINFO_XCROUCH){
			return(TOUCHA_KURAIC);
		}
		else if(info->guard & GUARDINFO_XSTAND){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if(info->guard & GUARDINFO_XJAMP){
			return(TOUCHA_GUARDC);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH)){
			return(TOUCHA_KURAIC);
		}
		else if((info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_GUARDC);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XJAMP)){
			pdat->aid = ACTID_SHOWERF;
			return(0);
		}
		else if((info->guard & GUARDINFO_XSTAND) && (info->guard & GUARDINFO_XCROUCH) && (info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_KURAIC);
		}
		else{
			if(atariauto == 0){return(TOUCHA_KURAIC);}
			else if(atariauto == 1){pdat->aid = ACTID_SHOWERF;return(0);}
			else {return(TOUCHA_GUARDC);}
		}
	}




	//AQh~
	if(pdat->aid==ACTID_DOWN2)return(0);
	//VXe`쒆iłɃK[ĥƂ̂݃K[hj
	if(pdat->aid & ACTID_SYSTEM){
		if(pdat->aid & ACTID_KUCYU){////Wv쒆
			if(pdat->aid & ACTID_GUARD)return(TOUCHA_GUARDJ);
			else return(TOUCHA_KURAIJ);
		}
		else if(pdat->aid & ACTID_SYAGAMI){//Ⴊݒ
			if(!(info->guard & GUARDINFO_XCROUCH)){
				if(pdat->aid & ACTID_GUARD)return(TOUCHA_GUARDC);
				else return(TOUCHA_KURAIC);
			}
		}
		else{
			if(!(info->guard & GUARDINFO_XSTAND)){
				if(pdat->aid & ACTID_GUARD)return(TOUCHA_GUARDS);
				else return(TOUCHA_KURAIS);
			}
		}
	}

	//U쒆iɋ炤j
	if((pdat->aid & ACTID_ATTACK) || (pdat->aid & ACTID_KURAI)){
		if(pdat->aid & ACTID_KUCYU){//Wv쒆
			return(TOUCHA_KURAIJ);
		}
		else if(pdat->aid & ACTID_SYAGAMI){//Ⴊݒ
			return(TOUCHA_KURAIC);
		}
		else return(TOUCHA_KURAIS);
	}

	//{쒆io[ijĂ΃K[hj
	if(pdat->aid & ACTID_KUCYU){//Wv쒆
		if(pdat->aid==ACTID_RAKKA && (key_now & KEYSTA_BACK)){//쒆Ȃ󒆃K[hoȂZłK[h
			return(TOUCHA_GUARDJ);
		}
		if((key_now & KEYSTA_BACK) && !(info->guard & GUARDINFO_XJAMP)){
			return(TOUCHA_GUARDJ);
		}
		else return(TOUCHA_KURAIJ);
	}
	if(key_now & KEYSTA_BACK){
		if(key_now & KEYSTA_DOWN){
			if(info->guard & GUARDINFO_XCROUCH){
				return(TOUCHA_KURAIC);
			}
			else {
				return(TOUCHA_GUARDC);
			}
		}
		else{
			if(info->guard & GUARDINFO_XSTAND){
				return(TOUCHA_KURAIS);
			}
			else {
				return(TOUCHA_GUARDS);
			}
		}
	}
	else{
		if(pdat->aid & ACTID_SYAGAMI)return(TOUCHA_KURAIC);
		else return(TOUCHA_KURAIS);
	}
}


DWORD CCharacter::TouchB(ATTACKINFO *info,BOOL hit)
{
	if(info->id == DMG_BUGGY){
		if(hit)buggycrs+=3;
		else buggycrs+=1;
	}
	if(info->id == DMG_SANADA){
		if(hit)sanadacrs+=3;
		else sanadacrs+=1;
	}
	if(info->id == DMG_SHINRYU){
		if(hit)shinryuhit+=1;
		else mochiketsu+=1;
	}
	if(info->id == DMG_TSUIRAKU){
		noburnd=1;
	}
	return(0);
}

void CCharacter::movex(double x)
{
	if(pdat->muki)x*=-1;
	pdat->x +=x;
}

int CCharacter::zurex(double x)
{
	if(pdat->muki)return((int)(x*-1));
	else return((int)(x));
}

BOOL CCharacter::ChainCombo(DWORD chainid)
{
	if(chainlist & chainid)return(FALSE);

	chainlist |= chainid;
	return(TRUE);
}

BOOL CCharacter::com236236(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com214214(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com624(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com426(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com486(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_UP | KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_UP | KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com66(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD2|KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst+=1;
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD2|KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com44(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK2|KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst+=1;
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK2|KEYSTA_BACK);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com236426(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com64628(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_UP);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com21426(int dt)
{
	int ofst=0;

	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_FOWORD);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN | KEYSTA_BACK);
	if(ofst<0)return(FALSE);
	ofst=(*pdat->fpack->pf_seekkey)(pdat->cid,ofst,dt,KEYSTA_DOWN);
	if(ofst<0)return(FALSE);

	return(TRUE);
}

BOOL CCharacter::com_nage(DWORD maai)
{
	DWORD hm,vm,eaid;
	(*pdat->fpack->pf_getmaai)(pdat->cid,&hm,&vm,&eaid);

	if(eaid & ACTID_KUCYU){
		return(FALSE);
	}
	if(hm > maai){
		return(FALSE);
	}

	return(TRUE);
}

int GetRandNum(int num)//_io[@Aq\[X
{
	srand(timeGetTime());
	return(rand()%num);
}
